#include <stdlib.h>
#include <stdio.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <errno.h>
#include "sharedMemory.h"

key_t getKey(const char *key_path, const uint8_t key_id) {
	key_t key = ftok(key_path, key_id);
	if (errno != 0) {
		perror("ftok");
		exit(1);
	}
	
	return key;
}

int getMemory(key_t key, size_t size) {
 int shmid = shmget(key, size, 0777|IPC_CREAT | S_IRWXU | IPC_EXCL);
 if (shmid == -1) {
	perror("shmget");
	exit(1);
 }
 return shmid;
}

int getExistingMemory(key_t key, size_t size) {
 int shmid = shmget(key, size, S_IRWXU );
 if (shmid == -1) {
	perror("shmget");
	exit(1);
 }
 return shmid;
}

void *attachMemory(int shmid) {
	void *shmaddr = shmat(shmid, NULL, 0);
	if (shmaddr == (void *) -1) {
		perror("shmat");
		exit(1);
	}
	return shmaddr;
}

void detachMemory(const void *shmaddr) {
	if (shmdt(shmaddr) == -1) {
		perror("shmdt");
		exit(1);
	}
}

void deallocateMemory(int shmid) {
	if (shmctl(shmid, IPC_RMID, 0) == -1) {
		perror("shmctl");
		exit(1);
	}
}

